/*
 * VITAL-5G monitoring platform
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.nfvmano.v5g.monitoring.api;

import it.nextworks.nfvmano.v5g.monitoring.ApiCallback;
import it.nextworks.nfvmano.v5g.monitoring.ApiClient;
import it.nextworks.nfvmano.v5g.monitoring.ApiException;
import it.nextworks.nfvmano.v5g.monitoring.ApiResponse;
import it.nextworks.nfvmano.v5g.monitoring.Configuration;
import it.nextworks.nfvmano.v5g.monitoring.Pair;
import it.nextworks.nfvmano.v5g.monitoring.ProgressRequestBody;
import it.nextworks.nfvmano.v5g.monitoring.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import it.nextworks.nfvmano.v5g.monitoring.model.CreateMetricResponse;
import it.nextworks.nfvmano.v5g.monitoring.model.MonitoringInfrastructureMetric;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class InfrastructureMetricsApi {
    private ApiClient apiClient;

    public InfrastructureMetricsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public InfrastructureMetricsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for createInfrastructureMetric
     * @param body A new &#x60;InfrastructureMetric&#x60; to be created. (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call createInfrastructureMetricCall(MonitoringInfrastructureMetric body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/infrastructure";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call createInfrastructureMetricValidateBeforeCall(MonitoringInfrastructureMetric body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling createInfrastructureMetric(Async)");
        }
        
        com.squareup.okhttp.Call call = createInfrastructureMetricCall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Create a InfrastructureMetric
     * Creates a new instance of a &#x60;InfrastructureMetric&#x60;.
     * @param body A new &#x60;InfrastructureMetric&#x60; to be created. (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public CreateMetricResponse createInfrastructureMetric(MonitoringInfrastructureMetric body) throws ApiException {
        return createInfrastructureMetricWithHttpInfo(body).getData();
    }

    /**
     * Create a InfrastructureMetric
     * Creates a new instance of a &#x60;InfrastructureMetric&#x60;.
     * @param body A new &#x60;InfrastructureMetric&#x60; to be created. (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<CreateMetricResponse> createInfrastructureMetricWithHttpInfo(MonitoringInfrastructureMetric body) throws ApiException {
        com.squareup.okhttp.Call call = createInfrastructureMetricValidateBeforeCall(body, null, null);
        return apiClient.execute(call, new TypeToken<CreateMetricResponse>(){}.getType());
    }

    /**
     * Create a InfrastructureMetric (asynchronously)
     * Creates a new instance of a &#x60;InfrastructureMetric&#x60;.
     * @param body A new &#x60;InfrastructureMetric&#x60; to be created. (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call createInfrastructureMetricAsync(MonitoringInfrastructureMetric body, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = createInfrastructureMetricValidateBeforeCall(body, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getInfrastructureMetrics
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getInfrastructureMetricsCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/infrastructure";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getInfrastructureMetricsValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = getInfrastructureMetricsCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * List All InfrastructureMetrics
     * Gets a list of all &#x60;InfrastructureMetric&#x60; entities.
     * @return List&lt;InfrastructureMetric&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<MonitoringInfrastructureMetric> getInfrastructureMetrics() throws ApiException {
        ApiResponse<List<MonitoringInfrastructureMetric>> resp = getInfrastructureMetricsWithHttpInfo();
        return resp.getData();
    }

    /**
     * List All InfrastructureMetrics
     * Gets a list of all &#x60;InfrastructureMetric&#x60; entities.
     * @return ApiResponse&lt;List&lt;InfrastructureMetric&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<MonitoringInfrastructureMetric>> getInfrastructureMetricsWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = getInfrastructureMetricsValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<List<MonitoringInfrastructureMetric>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * List All InfrastructureMetrics (asynchronously)
     * Gets a list of all &#x60;InfrastructureMetric&#x60; entities.
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getInfrastructureMetricsAsync(final ApiCallback<List<MonitoringInfrastructureMetric>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getInfrastructureMetricsValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<MonitoringInfrastructureMetric>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
